%define auth_ldap_version 2.0.3
%define easy_rsa_version 2.2.0_master

%define plugindir %_libdir/%name/plugins
%bcond_without ldap


Summary:	A Secure TCP/UDP Tunneling Daemon
Name:		openvpn
Version:	2.4.7
Release:	%mkrel 4
URL:		http://openvpn.net/
Source0:	http://openvpn.net/release/openvpn-%{version}.tar.xz
Source1:	https://github.com/downloads/OpenVPN/easy-rsa/easy-rsa-%{easy_rsa_version}.tar.xz
Source2:	dhcp.sh
Patch0:		%{name}-own-user.patch
Patch1:		openvpn-adding-routes.patch
Patch3:		openvpn-2.0.5-pinit.patch
Patch4:		openvpn-2.1_rc1.openvpn_user.patch
Patch10:    openvpn-script-security.patch
Patch12:    openvpn-2.1.1-initinfo.patch
License:	GPLv2
Group:		Networking/Other
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	liblzo-devel 
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
BuildRequires:	%{_lib}pkcs11-helper-devel >= 1.11
BuildRequires:	automake
Requires(pre):	rpm-helper
Requires(preun): rpm-helper
Requires(post): rpm-helper
Requires(postun): rpm-helper

Requires:   %{_lib}nettle7
Requires:   perl-Authen-PAM

%description
OpenVPN is a robust and highly flexible tunneling application that  uses
all of the encryption, authentication, and certification features of the
OpenSSL library to securely tunnel IP networks over a single UDP port.

64bit version does not contain the ldap plugin.


%prep
%setup -q -n openvpn-%{version} -a 1
%patch0 -p0
%patch1 -p0
%patch3 -p0
%patch4 -p1
#%patch6 -p1
%patch10 -p0
#%patch11 -p0
%patch12 -p0

%build
%serverbuild
#./pre-touch
aclocal
automake
autoconf

CFLAGS="%{optflags} -fPIC" CCFLAGS="%{optflags} -fPIC"
%configure2_5x --disable-static --enable-lzo --enable-password-save --enable-pkcs11 \
	       --enable-plugin-auth-pam --enable-plugin-down-root
%make

# plugins
%make -C src/plugins/down-root
%make -C src/plugins/auth-pam


pushd easy-rsa-%{easy_rsa_version}
%configure2_5x \
	--with-easyrsadir=%{_datadir}/%{name}/easy-rsa
%make
popd


%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std
%make_install -C easy-rsa-%{easy_rsa_version}

install -m755 distro/rpm/openvpn.init.d.rhel -D %{buildroot}%{_initrddir}/%{name}
install -d %{buildroot}%{_sysconfdir}/%{name}

mkdir -p %{buildroot}%{_datadir}/%{name}
cp -pr sample/sample-{config-file,key,script}s %{buildroot}%{_datadir}/%{name}
	
mkdir -p %{buildroot}%{_datadir}/%{name}
install -d %{buildroot}%{_localstatedir}/lib/%{name}

#plugins
mkdir -p %{buildroot}%{plugindir}

install -m755 %{SOURCE2} %{buildroot}%{_datadir}/%{name}

# remove unwanted files
rm -f %{buildroot}%{plugindir}/*.la
rm -rf %{buildroot}%{_includedir}
rm -rf %{buildroot}/%{_datadir}/doc/easy-rsa

%clean
rm -rf %{buildroot}

%pre
%_pre_useradd %{name} %{_localstatedir}/lib/%{name} /bin/true

%post
%_post_service %{name}

%preun
%_preun_service %{name}

%postun
%_postun_userdel %{name}

%files
%defattr(-,root,root,0755)
%doc AUTHORS INSTALL PORTS README
%doc src/plugins/*/README.*
%{_mandir}/man8/%{name}.8*
%{_sbindir}/%{name}
%{_datadir}/%{name}
%dir %{_sysconfdir}/%{name}
%{_initrddir}/%{name}
%dir %{_localstatedir}/lib/%{name}
%dir %plugindir
%plugindir/*.so


%changelog
* Mon Dec 02 2019 tex - 2.4.7-4pclos2019
- rebuild against updates

* Sat Jul 27 2019 tex - 2.4.7-3pclos2019
- rebuild against updates

* Tue Jul 02 2019 tex - 2.4.7-2pclos2019
- rebuild against updates

* Tue Mar 05 2019 tex - 2.4.7-1pclos2019
- update

* Tue Jan 15 2019 tex - 2.4.5-2pclos2019
- rebuild against updates

* Sun Apr 08 2018 bb2 <bb2> - 2.4.5-1pclos2018
- new version

* Sat Dec 10 2016 bb <bb> - 2.3.14-1pclos2017
- update


